﻿Public Class GroessenTest
    ''' <summary>
    ''' Get the resolution of the video from the dimensions provided by MediaInfo.dll
    ''' </summary>
    ''' <param name="fiRes"></param>
    ''' <returns></returns>
    Public Shared Function OLDGetResFromDimensions(ByVal fiRes As MediaContainers.Video) As String
        Dim resOut As String = String.Empty
        Try
            If Not String.IsNullOrEmpty(fiRes.Width) AndAlso Not String.IsNullOrEmpty(fiRes.Height) AndAlso Not String.IsNullOrEmpty(fiRes.Aspect) Then
                Dim iWidth As Integer = Convert.ToInt32(fiRes.Width)
                Dim iHeight As Integer = Convert.ToInt32(fiRes.Height)
                Dim sinADR As Single = Convert.ToSingle(fiRes.Aspect)

                Select Case True
                    Case iWidth < 640
                        resOut = "SD"
                    'exact
                    Case (iWidth = 3840 AndAlso iHeight = 2160) OrElse (iWidth = 3996 AndAlso iHeight = 2160) OrElse (iWidth = 4096 AndAlso iHeight = 2160) OrElse (iWidth = 5120 AndAlso iHeight = 2160)
                        resOut = "2160"
                    Case (iWidth = 2560 AndAlso iHeight = 1440)
                        resOut = "1440"
                    Case (iWidth = 1920 AndAlso (iHeight = 1080 OrElse iHeight = 800)) OrElse (iWidth = 1440 AndAlso iHeight = 1080) OrElse (iWidth = 1280 AndAlso iHeight = 1080)
                        resOut = "1080"
                    Case (iWidth = 1366 AndAlso iHeight = 768) OrElse (iWidth = 1024 AndAlso iHeight = 768)
                        resOut = "768"
                    Case (iWidth = 960 AndAlso iHeight = 720) OrElse (iWidth = 1280 AndAlso (iHeight = 720 OrElse iHeight = 544))
                        resOut = "720"
                    Case (iWidth = 1024 AndAlso iHeight = 576) OrElse (iWidth = 720 AndAlso iHeight = 576)
                        resOut = "576"
                    Case (iWidth = 720 OrElse iWidth = 960) AndAlso iHeight = 540
                        resOut = "540"
                    Case (iWidth = 852 OrElse iWidth = 720 OrElse iWidth = 704 OrElse iWidth = 640) AndAlso iHeight = 480
                        resOut = "480"
                    'by ADR
                    Case sinADR >= 1.4 AndAlso iWidth = 3840
                        resOut = "2160"
                    Case sinADR >= 1.4 AndAlso iWidth = 2560
                        resOut = "1440"
                    Case sinADR >= 1.4 AndAlso iWidth = 1920
                        resOut = "1080"
                    Case sinADR >= 1.4 AndAlso iWidth = 1366
                        resOut = "768"
                    Case sinADR >= 1.4 AndAlso iWidth = 1280
                        resOut = "720"
                    Case sinADR >= 1.4 AndAlso iWidth = 1024
                        resOut = "576"
                    Case sinADR >= 1.4 AndAlso iWidth = 960
                        resOut = "540"
                    Case sinADR >= 1.4 AndAlso iWidth = 852
                        resOut = "480"
                    'loose
                    Case iWidth > 2560 AndAlso iHeight > 1440
                        resOut = "2160"
                    Case iWidth > 1920 AndAlso iHeight > 1080
                        resOut = "1440"
                    Case iWidth >= 1200 AndAlso iHeight > 768
                        resOut = "1080"
                    Case iWidth >= 1000 AndAlso iHeight > 720
                        resOut = "768"
                    Case iWidth >= 1000 AndAlso iHeight > 500
                        resOut = "720"
                    Case iWidth >= 700 AndAlso iHeight > 540
                        resOut = "576"
                    Case iWidth >= 700 AndAlso iHeight > 480
                        resOut = "540"
                    Case Else
                        resOut = "480"
                End Select
            End If
        Catch ex As Exception
            logger.XError(ex, New StackFrame().GetMethod().Name)
        End Try

        If Not String.IsNullOrEmpty(resOut) Then
            If String.IsNullOrEmpty(fiRes.Scantype) Then
                Return String.Concat(resOut)
            Else
                Return String.Concat(resOut, If(fiRes.Scantype.ToLower = "progressive", "p", "i"))
            End If
        Else
            Return String.Empty
        End If
    End Function


    Private Structure VSizes
        Public Hor As Integer
        Public RetVal As String
        Public Sub New(ByVal H As Integer, ByVal R As String)
            Hor = H
            RetVal = R
        End Sub
    End Structure
    ''' <summary>
    ''' Get the resolution of the video from the dimensions provided by MediaInfo.dll
    ''' </summary>
    ''' <param name="fiRes"></param>
    ''' <returns></returns>
    ''' 
    Public Shared Function GetResFromDimensions(ByVal fiRes As MediaContainers.Video) As String
        Dim resOut As String = String.Empty
        Dim i As Integer
        '
        ' MAM 09.03.2017
        ' Array (in aufsteigender Reihenfolge!!!) der horizontalen Pixels und des gewünschten Ergebniswertes (String)
        '
        ' Achtung beim Hinzufügen neuer Werte: unbedingt richtig einsortieren!!!
        '
        Dim Vs() As VSizes = {
            New VSizes(400, "SD"),
            New VSizes(640, "NTSC"),
            New VSizes(720, "PAL"),
            New VSizes(1280, "720"),
            New VSizes(1920, "1080"),
            New VSizes(3840, "2160"),
            New VSizes(9999999, "TOOBIG")
        }
        Try
            If Not String.IsNullOrEmpty(fiRes.Width) Then
                Dim iWidth As Integer = Convert.ToInt32(fiRes.Width)

                For i = 0 To Vs.Count - 1
                    If Vs(i).Hor >= iWidth Then
                        resOut = Vs(i).RetVal
                        Exit For
                    End If
                Next
            End If

        Catch ex As Exception
            ' Achtung! leider kann man keine Sub "Error" definieren, reserviertes Keyword! Also mach das "X" davor weg, wenn Du die Funktion ins
            ' richtige Projekt kopierst!

            logger.XError(ex, New StackFrame().GetMethod().Name)
        End Try

        If Not String.IsNullOrEmpty(resOut) Then
            If String.IsNullOrEmpty(fiRes.Scantype) Then
                Return String.Concat(resOut)
            Else
                Return String.Concat(resOut, If(fiRes.Scantype.ToLower = "progressive", "p", "i"))
            End If
        Else
            Return String.Empty
        End If
    End Function
End Class
